package user;

import java.util.Collection;

import org.drools.KnowledgeBase;
import org.drools.KnowledgeBaseFactory;
import org.drools.builder.KnowledgeBuilder;
import org.drools.builder.KnowledgeBuilderError;
import org.drools.builder.KnowledgeBuilderErrors;
import org.drools.builder.KnowledgeBuilderFactory;
import org.drools.builder.ResourceType;
import org.drools.definition.KnowledgePackage;
import org.drools.io.ResourceFactory;
import org.drools.runtime.StatefulKnowledgeSession;

public class Test {
	
	public static void main(String[] args) {
		KnowledgeBase base = KnowledgeBaseFactory.newKnowledgeBase();
		StatefulKnowledgeSession s = base.newStatefulKnowledgeSession();
		
		// insert here will be err
		User user = new User(); 
		s.insert(user);
		
		// add rule
		KnowledgeBuilder builder = KnowledgeBuilderFactory.newKnowledgeBuilder();
		builder.add(ResourceFactory.newClassPathResource("user.drl", Test.class), ResourceType.DRL);
		KnowledgeBuilderErrors errs = builder.getErrors();
		if (!errs.isEmpty()) {
			for (KnowledgeBuilderError e: errs) {
				System.out.println(e.toString());
			}
		}
		Collection<KnowledgePackage> col = builder.getKnowledgePackages();
		base.addKnowledgePackages(col);
		
		// insert here is ok
//		User user = new User(); 
//		s.insert(user);
		
		// fire
		s.fireAllRules();
	}
}
